<template>
  <v-container>
    <h2 class="text-center mb-4">Students</h2>
    <v-row justify="center">
      <v-data-table
        v-model="rows_selected"
        :headers="table_fields"
        :items="students.students"
        sort-by="firstname"
        sort-desc
        item-key="_id"
        class="elevation-1"
      >
        <template v-slot:[`item.actions`]="{ item }">
          <v-icon color="error" large @click="deleteItem(item)">
            mdi-delete
          </v-icon>
        </template>
      </v-data-table>
      <delete-dialog
        v-if="deleteDialog"
        :message="'Are you sure you want to delete this student?'"
        :width="'700px'"
        @deleteConfirm="confirmDelete"
      />
    </v-row>
  </v-container>
</template>
<script>
import axios from "axios";
import DeleteDialog from "./Helpers/deleteDialog.vue";
import { mapActions, mapGetters } from "vuex";

export default {
  components: {
    DeleteDialog
  },
  data() {
    return {
      selectedStudentToDelete: {},
      dialog: false,
      deleteDialog: false,
      rows_selected: [],
      table_fields: [
        { value: "firstname", text: "First Name" },
        { value: "lastname", text: "Last Name" },
        { value: "email", text: "Email" },
        { value: "address", text: "Address" },
        { value: "creditcard", text: "Credit Card" },
        { value: "enrolledCourse", text: "Course Enrolled" },
        { text: "Actions", value: "actions", sortable: false }
      ]
    };
  },
  mounted() {
    this.getStudents();
  },
  computed: {
    ...mapGetters(["students"])
  },
  methods: {
    ...mapActions(["getStudents"]),
    deleteItem(item) {
      console.log("Item to delete: ", item);
      this.selectedStudentToDelete = item;
      this.deleteDialog = true;
    },
    confirmDelete(confirm) {
      console.log("confirm", confirm);
      if (confirm) {
        const payload = {
          budgets: this.rows_selected
        };
        axios
          .delete(
            `${process.env.VUE_APP_API_ADDRESS}/students/${this.selectedStudentToDelete._id}`,
            {
              data: payload
            }
          )
          .then(() => {
            this.getStudents();
          })
          .catch(err => console.log(err));
        this.deleteDialog = false;
      } else this.deleteDialog = false;
    }
  }
};
</script>
